#include <iostream>
#include <opencv2/opencv.hpp>
#include <Windows.h>
#define KEY_PUSH(key) (GetAsyncKeyState(key) & 0x0001)
#define KEY_DOWN(key) (GetAsyncKeyState(key) & 0x8000)


using namespace std;
using namespace cv;

const int W = 640;
const int H = 480;

bool calib = false;
bool firstpoint = false;
int h;
int s;
int v;
Point p1, p2;
Point points[8];
int hmin=38, hmax=66, smin=35, smax=140, vmin=110, vmax=255;

void mouseFunc(int event, int x, int y, int flag, void *param)
{
	switch (event)
	{
	case CV_EVENT_LBUTTONDOWN:
		firstpoint = true;
		p1.x = x;
		p1.y = y;
		p2 = p1;
			break;
	case CV_EVENT_LBUTTONUP:
		firstpoint = false;
		p2.x = x;
		p2.y = y;
		calib = true;
			break;
	case CV_EVENT_MOUSEMOVE:
		if(firstpoint == true)
		{ 
			p2.x = x;
			p2.y = y;
		}
		break;
	}

}

int main()
{
	for(int i = 0; 8 > i; i++)
	{
		points[i].x = 0;
		points[i].y = 0;
	}
	namedWindow("Image window");
	setMouseCallback("Image window", mouseFunc, NULL);
	namedWindow("Window");
	createTrackbar("Hmin", "Window", &hmin, 255);
	createTrackbar("Hmax", "Window", &hmax, 255);
	createTrackbar("Smin", "Window", &smin, 255);
	createTrackbar("Smax", "Window", &smax, 255);
	createTrackbar("Vmin", "Window", &vmin, 255);
	createTrackbar("Vmax", "Window", &vmax, 255);
	VideoCapture capture(1);
	while (KEY_DOWN(VK_CONTROL) == 0)
	{
		cv::Mat image, hsv_image;
		capture >> image;
		//cout << (int)image.at<Vec3b>(H / 2, W / 2)[0] << " " << (int)image.at<Vec3b>(H / 2, W / 2)[1] << " " << (int)image.at<Vec3b>(H / 2, W / 2)[2] << endl;
		cvtColor(image, hsv_image, CV_BGR2HSV);
		Mat GoodPoints(H, W, CV_8UC1);
		GoodPoints = Scalar(0);
		for (int i = 0; i < W; i++)
		{
			for (int i2 = 0; i2 < H; i2++)
			{
				h = hsv_image.at<Vec3b>(i2, i)[0];
				s = hsv_image.at<Vec3b>(i2, i)[1];
				v = hsv_image.at<Vec3b>(i2, i)[2];
				if (h >= hmin && s >= smin && v >= vmin && h <= hmax && s <= smax && v <= vmax)
				{
					image.at<Vec3b>(i2, i)[0] = 255;
					image.at<Vec3b>(i2, i)[1] = 0;
					image.at<Vec3b>(i2, i)[2] = 0;
					GoodPoints.at<unsigned char>(i2, i) = 255;
				}
			}
		}
		imshow("GoodPoints", GoodPoints);
		if (KEY_PUSH('1'))
		{
			calib = 0;
			while (calib == false)
			{
				if (firstpoint == true)
				{
					Mat image2=image.clone();
					rectangle(image2, p1, p2, Scalar (0, 0, 255), 3);
					imshow("Image window", image2);
				}
				waitKey(1);
			}
			points[0] = p1;
			points[4] = p2;
		}
		if (KEY_PUSH('2'))
		{
			calib = 0;
			while (calib == false)
			{
				if (firstpoint == true)
				{
					Mat image2 = image.clone();
					rectangle(image2, p1, p2, Scalar(255, 255, 255), 3);
					imshow("Image window", image2);
				}
				waitKey(1);
			}
			points[1] = p1;
			points[5] = p2;
		}
		if (KEY_PUSH('3'))
		{
			calib = 0;
			while (calib == false) 
			{
				if (firstpoint == true)
				{
					Mat image2 = image.clone();
					rectangle(image2, p1, p2, Scalar(0, 255, 0), 3);
					imshow("Image window", image2);
				}
				waitKey(1);
			}
			points[2] = p1;
			points[6] = p2;
		}
		if (KEY_PUSH('4'))
		{
			calib = 0;
			while (calib == false) 
			{
				if (firstpoint == true)
				{
					Mat image2 = image.clone();
					rectangle(image2, p1, p2, Scalar(255, 0, 255), 3);
					imshow("Image window", image2);
				}
				waitKey(1);
			}
			points[3] = p1;
			points[7] = p2;
		}
		for (int i = 0; 4 > i; i++)
		{
			Mat image3(H, W, CV_8UC1);
			image3 = Scalar(0);
			rectangle(image3, points[i], points[i + 4], Scalar(255), -1);
			Mat image4 = GoodPoints & image3;
			int n = countNonZero(image4);
			cout << n << " ";
		}
		cout << endl;
		//cout << points[0] << " " << points[1] << " " << points[2] << " " << points[3] << " " << points[4] << " " << points[5] << " " << points[6] << " " << points[7];
		imshow("Image window", image);
		waitKey(1);
	}
	return 0;
}